]> git.sesse.net Git - backup.sh/blobdiff - backup.sh
Slightly more consistent coding style.
[backup.sh] / backup.sh
index 4d8565bea85cefd208d9338f9ffa59feadbdef14..c3143d71cd78f19495478b372369201a6a929696 100755 (executable)
--- a/backup.sh
+++ b/backup.sh
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/bash
 # backup.sh
 # 
 # Backup up Unix-like computers
 # It's a bit peculiar, but quite effective. The following is worth keeping in
 # mind when hacking:
 #
-# KISS. And by that I mean really simple. Only regular Unix commands, please
-# (but GNU extensions are used).
-#
 # Because of the way we run this script from cron, informational logging goes
 # to stderr and warnings and errors to stdout. This way, we get mail whenever
 # stuff fails, and other output is redirected to the log file.
 # 
-# The computers are backed up in parallell (but the filesystems on each
-# computer in serial). This is implemented highly simplistic, with forking
-# subshells. The script has no concept about threads, and stuff might go wrong,
-# which usually requires manual cleanups.
-#
 # The script is halfway Norwegian and halfway English. Newer modifications are
 # in English, we should probably stick to that.
 
-# TODO(sesse, 2007-12-16): 
-#  * Sjekk hvorfor .idx-filene til UD er blitt 0 for siste fullbackuper
-#  * Rydde uleselig kode fra linje 211 og litt nedover
+# The computer to backup.
+computer=$1
 
 # Configuration
-LOCKFILE=/home/backup/backuprun.lockfile
-confdir=/home/backup/conf/           # Configuration files
-storagedir=/backup                   # Where we keep backups
-maksantallfulle=3                    # Number of full backups
-dagermellomfulle=30                  # Days between full backups
-DATE=`date "+%Y%m%d%H%M"`            #format: touch
-DATEs=`date "+%Y-%m-%d %H:%M"`       #format: tar
+LOCKFILE=/home/backup/backuprun.lockfile.$computer
+confdir=/home/backup/conf/              # Configuration files
+storagedir=/backup                      # Where we keep backups
+maxnumfull=3                            # Number of full backups
+daysbetweenfull=30                      # Days between full backups
+daysbetweenfullforfixed=32              # Days between full backups for machines with fixed
+                                        # full-backup date (in case the fixed day gets missed)
+DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
+DATE=`date "+%Y%m%d%H%M"`               #format: touch
+DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
 
 # Exclude-pattern
 exclude=$confdir/exclude
 [ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
 
-# Initially, we consider everything to be just fine.
-R=0
+if [ -z "$computer" ]; then
+       echo "Usage: $0 COMPUTER"
+       exit 1
+fi
 
 # Die more or less gracefully (at least notify user)
 die() {
-       echo `date`": Something nasty happened, and since I fork a lot:"
-        echo `date`": I CANNOT CLEAN UP THE MESS MYSELF."
-       echo `date`": You need to get rid of lost process named stuff like $0, tar and ssh."
-       exit 255
+       echo `date`": Something nasty happened."
+       rm $LOCKFILE
+       exit 1
+}
+diemsg() {
+       echo `date`": $computer: $@"
+       die
 }
 
 # Trap C-c and kill
@@ -59,255 +58,221 @@ trap die SIGINT SIGTERM
 
 # Don't start if we're already running
 if [ -e $LOCKFILE ]; then
-       echo `date`": $LOCKFILE exists, exiting."
-       echo `date`": $LOCKFILE exists, exiting." >&2
+       echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
+       echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
        exit 1
 fi;
 touch $LOCKFILE
-
-#syntax of remotestat:
-#hostname:/directory/
-remotestatf=$confdir/remotestat
-[ -f $remotestatf ] && remotestat=`cat $remotestatf`
-###
-
-PATH=/local/bin:$PATH:/store/bin
-export PATH
+echo $$ > $LOCKFILE
 
 echo `date`": Backup run starting" >&2
 
 umask 027
 
-# The computers we want to back up
-unixcomputers=`cat $confdir/computers.unix \
-  | grep -v "^#" \
-  | grep -v "^$" `
-
-# Backup only one computer, from command line?
-if [ $1 ] ; then 
-  unixcomputers=$1
-fi;
-
 
-#selve backupen
-# krever at noen variabler er satt
-# krever at vi er i rett katalog
 backup()
 {
+       echo -n `date` >&2
+       printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
+
+       SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
+       incrementalsnar="/root/.backup/${sfilesystem}.snar"
+       if [ "$backuplevel" = "daglig" ]
+       then
+               # If incremental backup, we need to copy the incremental status to $computer.
+               # If it does not exist, whine a bit and then run date-based instead.
+               if [ -s "$SNARFILE" ]; then
+                       if ! scp $SNARFILE root@$computer:$incrementalsnar; then
+                               diemsg "Could not copy .incremental.snar to $computer"
+                       fi
+                       lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
+               else
+                       echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
+                       incrementalsnar=""
+                       lastd=`cat ../.date`
+                       lastcmd="--newer='$lastd'"
+               fi
+       else
+               lastcmd="--listed-incremental=$incrementalsnar"
+       fi
+
+       # We try to run tar on the remote computer
+       #    c create archive
+       #    C change to directory first
+       #    . where to start taring (see C)
+       #    $lastcmd only files newer than this
+       #    --one-file-system don't traverse file systems
+       #    --use-compress-program compress it using gzip or pigz
+       #    --exclude-from file to get exclusion pattern from
+       #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
+       #    file and build a file list, respectivly.  
+       TARFILE=$DATE.tmp
+       TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
+               --exclude-from=/root/.backup/exclude\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
+       echo `date`" $computer: Running $TARCMD" >&2
+       eval $TARCMD > $DATE.idx
+
+       if [ $? -eq 0 ] && [ -s $TARFILE ]; then
+               # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
+
+               if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
+                       diemsg "Could not copy .incremental.snar from $computer"
+               fi
+
+               # Move tar file in place
+               mv $TARFILE $DATE.tgz
+               mv $SNARFILE.tmp $SNARFILE
+
+               # Update timestamp
+               echo $DATEs > ../.date && touch -t $DATE ../.date
+
+               # Make a sorted file list as well
+               sort -k6 < $DATE.idx > $DATE.sdx
+
+               # Fix permissions
+               chmod 600 *tgz                      #only for us
+               chmod 644 *sdx *idx 2>/dev/null     #everyone can read
+
+               # Let the remote computer know that we ran a successful backup (for nagios)
+               ssh root@$computer touch $filesystem/.lastbackup
+       else
+               # Something wrong happened.
+               rm $TARFILE
+               diemsg "tar failed or $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
+       fi
+}
 
- echo -n `date` >&2
- printf " $computer: $computer:$filesystem $backuplevel backup" >&2
-
- if [ "$backuplevel" = "daglig" ] || [ "$backuplevel" = "incremental" ]
- then
-  lastd=`cat ../.date`
-  lastcmd="--newer='$lastd'"
- else
-  lastcmd=""
- fi
-
- #if this client has a special tar
- #we need to find a better solution to this conf-issue
- if [ -f $confdir/tar.$computer ] ; then
-   tar=`cat $confdir/tar.$computer`
- else 
-   tar=tar
- fi
-
- # expand the exclude-path for use with tar
- exf=`ssh root@$computer "ls ~/.backup/exclude"`
-
- # We try to run tar on the remote computer
- #    z gzip it
- #    c create archive
- #    C change to directory first
- #    . where to start taring (see C)
- #    $lastcmd only files newer than this
- #    --one-file-system don't traverse file systems
- #    --exclude-from file to get exclusion pattern from
- #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
- #    file and build a file list, respectivly.  
- TARFILE=$DATE.tmp
- TARCMD="ssh root@$computer \"$tar --one-file-system -zcf - -C $filesystem . $lastcmd \
-       --exclude-from=$exf\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
- echo `date`" $computer: Running $TARCMD" >&2
- eval $TARCMD > $DATE.idx
-
- if [ -s $TARFILE ]; then
-  # File is >0 in size, we assume it worked.
-
-  # Move tar file in place
-  mv $TARFILE $DATE.tgz
-
-  # Update timestamp
-  echo $DATEs > ../.date && touch -t $DATE ../.date
-
-  # Make a sorted filelist
-  grep -v ^d $DATE.idx | sort -n -r -k 2 > $DATE.sdx
-
-  # Fix permissions
-  chmod 600 *tgz                      #only for us
-  chmod 644 *sdx *idx 2>/dev/null     #everyone can read
-
- else
-  # Something wrong happened.
-  rm $TARFILE
-  echo `date`" $computer: $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
-
-  # We don't want to return 0
-  R=1
- fi
+# Check that the target filesystem is mounted (actually check that it's not
+# the root filesystem)
+if [ ! -d "$storagedir/$computer" ]; then
+       diemsg "Target filesystem ($storagedir/$computer) does not exist. Aborting"
+fi
+rootfilesystem=`df -P /`
+targetfilesystem=`df -P "$storagedir/$computer"`
+if [ "$rootfilesystem" == "$targetfilesystem" ]; then
+       diemsg "Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
+fi
 
-}
+echo `date`" $computer: Backing up $computer" >&2
+
+# Try to SSH to the computer without entering a password.
+if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
+       diemsg "Could not use passwordless SSH."
+fi
 
-for computer in $unixcomputers
-do
-( 
- # Check that the target filesystem is mounted (actually check that it's not
- # the root filesystem)
- rootfilesystem=`df -P /`
- targetfilesystem=`df -P "$storagedir/$computer"`
- if [ "$rootfilesystem" == "$targetfilesystem" ]; then
-       echo `date`" $computer: Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
-       continue
- fi
-
- echo `date`" $computer: Backing up $computer" >&2
-
- # Try to SSH to the computer without entering a password.
- if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
-  echo `date`" $computer: Could not use passwordless SSH."
-
-  # We don't want to return 0
-  R=1
-  # Do next computer
-  continue;
- fi
- filesystems=""
-
- # Check dump bit in fstab
- filesystems=`ssh -n root@$computer "cat /etc/fstab" \
-  | grep -v nfs \
-  | grep -v "^#" \
-  | grep -v "^$" \
-  | awk '{ if ( $(NF-1) != "0" ) print $2}' `
-
- # Clean up our dir at this client
- if ! ssh root@$computer "rm -r ~/.backup ; mkdir -m 700 ~/.backup"; then
-  echo `date`" $computer: Could not create backup staging area at $computer:~/.backup - skipping backup of $computer"
-  R=1
-  continue;
- fi
-
- # Try to copy $exclude to $computer
- if ! scp $exclude root@$computer:~/.backup/exclude > /dev/null; then
-  echo `date`" $computer: Could not copy exclude.txt to $computer - skipping backup of $computer"
-  R=1
-  continue;
- fi
-
- # Try to copy preeexec and postexec if they exist
-# TODO: Gah, clean this mess!
- [ -f $confdir/preexec.$computer ] && (
-    scp $confdir/preexec.$computer  root@$computer:~/.backup/preexec >&2 ||
-     ( echo `date`" $computer: Could not copy preexec.$computer to $computer:~/.backup/preexec - skipping backup of $computer"
-       R=1
-       continue
-     )
-    )
- [ -f $confdir/postexec.$computer ] && (
-    scp $confdir/postexec.$computer root@$computer:~/.backup/postexec >&2 ||
-     ( echo `date`" $computer: Could not copy postexec.$computer to $computer:~/.backup/postexec - skipping backup of $computer"
-       R=1
-       continue
-     )
-    )
-
- # Try to run preexec if it exist
- if ! ssh root@$computer "[ ! -f ~/.backup/preexec ] || /bin/bash -x ~/.backup/preexec" >&2; then
-       echo `date`" $computer: Could not run $computer:~/.backup/preexec - skipping backup of $computer"
-       R=1
-       continue
- fi
-
-
- for filesystem in $filesystems
- do
-  # Remove / and $ (for Windows) for path names
-  sfilesystem=`echo $filesystem | tr '\/\$' '__'`
-
-  # Prepare storage area
-  mkdir -m 755 -p $storagedir/$computer/$sfilesystem/{full,daglig} 2>/dev/null
-  echo $filesystem > ${storagedir}/${computer}/.${sfilesystem}.name 
-  chmod 644 ${storagedir}/${computer}/.${sfilesystem}.name
-
-  # Default backuplevel
-  backuplevel=daglig
-
-  if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
-  then
-   # Take the first full backup of this filesystem on this computer
-   backuplevel=full
-   echo $DATEs > $storagedir/$computer/$sfilesystem/.date
-  fi
-
-  # Check if we want a full backup
-  if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$dagermellomfulle`" ]; then
-   backuplevel=full
-  fi
-  # We want to be here
-  cd $storagedir/$computer/$sfilesystem/$backuplevel || die
-
-  # Perform the actual backup
-  backup
-
-  # Check if this box has a custom number of full backups
-  if [ -f $confdir/maksfulle.$computer ] ; then
-    mf=$((`cat $confdir/maksfulle.$computer`+1))
-  else
-    mf=$(($maksantallfulle+1))
-  fi
-
-  # Delete old full backups
-  for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`
-  do
-   prefix=`echo $full | sed "s/\.[^.]*$//"`
-   echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
-   rm $prefix*
-  done
-
-  # Delete incremental backups older than the oldest full backup
-  oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
-  find \
-     $storagedir/$computer/$sfilesystem/daglig \
-     -type f \
-     \! -newer $oldf \
-     -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
-     -exec rm {} \; >&2
- done
-
- # Try to run postexec if it exist
- if ! ssh root@$computer "[ ! -f ~/.backup/postexec ] || /bin/bash -x ~/.backup/postexec" >&2; then
-       echo `date`" $computer: Could not run $computer:~/.backup/postexec"
-       R=1
- fi
-
-) &
+# Check if pigz is available
+if ssh -n root@$computer "pigz -V 2>/dev/null"; then
+       compressor=pigz
+else
+       echo `date`" $computer: pigz missing; falling back to gzip."
+       compressor=gzip
+fi
+
+# Check dump bit in fstab
+filesystems=`ssh -n root@$computer "cat /etc/fstab" \
+       | grep -v nfs \
+       | grep -v "^#" \
+       | grep -v "^$" \
+       | awk '{ if ( $(NF-1) != "0" ) print $2}' `
+
+# Clean up our dir at this client
+if ! ssh root@$computer "rm -r /root/.backup ; mkdir -m 700 /root/.backup"; then
+       diemsg "Could not create backup staging area at $computer:/root/.backup"
+fi
+
+# Try to copy $exclude to $computer
+if ! scp $exclude root@$computer:/root/.backup/exclude > /dev/null; then
+       diemsg "Could not copy exclude.txt to $computer"
+fi
+
+# Try to copy preeexec and postexec if they exist
+if [ -f $confdir/preexec.$computer ]; then
+       if ! scp $confdir/preexec.$computer  root@$computer:/root/.backup/preexec >&2; then
+               diemsg "Could not copy preexec.$computer to $computer:/root/.backup/preexec"
+       fi
+fi
+if [ -f $confdir/postexec.$computer ]; then
+       if ! scp $confdir/postexec.$computer root@$computer:/root/.backup/postexec >&2; then
+               diemsg "Could not copy postexec.$computer to $computer:/root/.backup/postexec"
+       fi
+fi
+
+# Try to run preexec if it exists
+if ! ssh root@$computer "[ ! -f /root/.backup/preexec ] || /bin/bash -x /root/.backup/preexec" >&2; then
+       diemsg "Could not run $computer:/root/.backup/preexec"
+fi
+
+for filesystem in $filesystems; do
+       # Remove / and $ (for Windows) for path names
+       sfilesystem=`echo $filesystem | tr '\/\$' '__'`
+
+       # Prepare storage area
+       mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
+       mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
+
+       # Default backuplevel
+       backuplevel=daglig
+
+       if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
+       then
+               # Take the first full backup of this filesystem on this computer
+               backuplevel=full
+               echo $DATEs > $storagedir/$computer/$sfilesystem/.date
+       fi
+
+       # Check if we want a full backup
+       if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
+               fullbackup_min_for_this_machine=$daysbetweenfullforfixed
+               if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
+                       backuplevel=full
+               fi
+       elif [ -f $confdir/fastfullbackupdag.$computer ]; then
+               fullbackup_min_for_this_machine=$daysbetweenfullforfixed
+               if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
+                       backuplevel=full
+               fi
+       else
+               fullbackup_min_for_this_machine=$daysbetweenfull 
+       fi
+
+       if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
+               backuplevel=full
+       fi
+
+       # We want to be here
+       cd $storagedir/$computer/$sfilesystem/$backuplevelmsg || die "$storagedir/$computer/$sfilesystem/$backuplevel does not exist"
+
+       # Perform the actual backup
+       backup
+
+       # Check if this box has a custom number of full backups
+       if [ -f $confdir/maksfulle.$computer ] ; then
+               mf=$((`cat $confdir/maksfulle.$computer`+1))
+       else
+               mf=$(($maxnumfull+1))
+       fi
+
+       # Delete old full backups
+       for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`; do
+               prefix=`echo $full | sed "s/\.[^.]*$//"`
+               echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
+               rm $prefix*
+       done
+
+       # Delete incremental backups older than the oldest full backup
+       oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
+       find \
+               $storagedir/$computer/$sfilesystem/daglig \
+               -type f \
+               \! -newer $oldf \
+               -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
+               -exec rm {} \; >&2
 done
 
-wait
+# Try to run postexec if it exist
+if ! ssh root@$computer "[ ! -f /root/.backup/postexec ] || /bin/bash -x /root/.backup/postexec" >&2; then
+       diemsg "Could not run $computer:/root/.backup/postexec"
+fi
 
 # Remove lockfile
 rm $LOCKFILE
-
-# Did anything go wrong?
-# (IMPORTANT NOTE: The R-business does not work as expected, since this script
-# forks itself).
-if [ $R != 0 ]; then
-       echo `date`": Backup run ended with errors, check logs."
-       exit 1
-else
-       echo `date`": Backup run ended" >&2
-fi